import * as React from 'react';
import {Table, Button, Input, InputProps, ButtonProps, Dropdown } from 'semantic-ui-react';

export class DiscoveryTable extends React.Component<any, any> {

  private serviceTemp: any;

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
      startIp: null,
      endIP: null,
      excludeIp: null,
      startPort: null,
      endPort: null
    };
  }

  componentWillMount() {
    this.serviceTemp = [
      { key: 'http', text: 'HTTP', value: 'http' },
      { key: 'ftp', text: 'FTP', value: 'ftp' },
      { key: 'snmp', text: 'SNMP', value: 'snmp' },
      { key: 'oracle', text: 'Oracle', value: 'oracle' },
      { key: 'mysql', text: 'MySQL', value: 'mysql' },
      { key: 'wmi', text: 'WMI', value: 'wmi' },
      { key: 'sql_server', text: 'SQL Server', value: 'sql_server' },
      { key: 'stmp', text: 'STMP', value: 'stmp' },
      { key: 'imap', text: 'IMAP', value: 'imap' },
      { key: 'ssh', text: 'SSH', value: 'ssh' },
      { key: 'telnet', text: 'Telnet', value: 'telnet' },
      { key: 'casandra', text: 'Casandra', value: 'casandra' },
      { key: 'mongodb', text: 'mongoDB', value: 'mongodb' },
      { key: 'rmi', text: 'RMI', value: 'rmi' }
    ];
  }

  handleInput(event: React.SyntheticEvent<HTMLInputElement>, data: InputProps) {
    // console.log( data.value);
    // console.log( event.target);
    // console.log(data.tabIndex);

    let value: string = data.value;
    switch (data.tabIndex) {
      case '0':{
        this.setState({
          startIp: value,
        });
        break;
      }
      case '1':{
        this.setState({
          endIP: value,
        });
        break;
      }
      case '2':{
        this.setState({
          excludeIp: value,
        });
        break;
      }
      case '3':{
        this.setState({
          startPort: value,
        });
        break;
      }
      case '4':{
        this.setState({
          endPort: value,
        });
        break;
      }
      default:{
        console.log("Error");
        break;
      }
    }

    console.log(this.state.startPort);
  }

  discoveryStartHandler(event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps) {
    this.props.onProbeChange(this.state);
  }

  render() {
    return (
      <div>
        <Table celled>
          <Table.Body>
            <Table.Row>
              <Table.Cell width='2'>Zone CIDR</Table.Cell>
              <Table.Cell width='7'><Input fluid disabled size='large' placeholder='Start IP' defaultValue='192.168.1.0/24' /></Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell>IP Range</Table.Cell>
              <Table.Cell>
                <Input tabIndex='1' size='large' placeholder='Start IP' onChange={this.handleInput.bind(this)} /> &nbsp;&nbsp;
                <Input tabIndex='2' size='large' placeholder='End IP' onChange={this.handleInput.bind(this)} /> &nbsp;&nbsp;
                <Input tabIndex='3' size='large' placeholder='Exclude IP' onChange={this.handleInput.bind(this)} />
              </Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell>Port Range</Table.Cell>
              <Table.Cell>
                <Input tabIndex='4'  size='large' placeholder='Start Port' onChange={this.handleInput.bind(this)} /> &nbsp;&nbsp;
                <Input tabIndex='5'  size='large' placeholder='End Port' onChange={this.handleInput.bind(this)} />
              </Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell>Service</Table.Cell>
              <Table.Cell>
                  <Dropdown placeholder='Service' fluid multiple selection options={this.serviceTemp}  />
              </Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell>End Port</Table.Cell>
              <Table.Cell><Input tabIndex='6' size='large' placeholder='End Port' onChange={this.handleInput.bind(this)} /></Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>
        <Button floated='right' onClick={this.discoveryStartHandler.bind(this)}> Start </Button>
      </div>
    );
  }
}