import * as React from 'react';
import { Table, Checkbox, Button } from 'semantic-ui-react';


export class NoauthProbes extends React.Component<any, any> {

  private data: any;
  private selectedIds: Array<string>;

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
      selected: [],
    };
    this.selectedIds = new Array();
  }


  componentWillMount() {
    this.data = [
      {
        "id": "11",
        "MetaNoAuthProbeStatus": {
          "name": "NORMAL"
        },
        "hostName": "insanity's windows",
        "macAddress": "14:fe:b5:9d:54:7e",
        "ipAddress": "192.168.1.105",
        "tempProbeKey": "45374d4egsdfw332",
        "apiKey": "45374d4egsdfw332",
        "domain": {

        },
        "probe": {

        },
      },
      {
        "id": "22",
        "MetaNoAuthProbeStatus": {
          "name": "NORMAL"
        },
        "hostName": "insanity's ubuntu",
        "macAddress": "14:fe:b5:9d:54:7e",
        "ipAddress": "192.168.1.105",
        "tempProbeKey": "45374d4egsdfw332",
        "apiKey": "45374d4egsdfw332",
        "domain": {

        },
        "probe": {

        },
      },
    ];
  }

  handleSelect(id: string) {
    let idx = this.selectedIds.indexOf(id);
    if (idx === -1) {
      this.selectedIds.push(id);
    } else {
      this.selectedIds.splice(idx, 1);
    }
    this.setState({
      selected: this.selectedIds,
    });
  }

  checkExist(id: string): boolean {
    if (this.state.selected.indexOf(id) === -1) {
      return false;
    }
    return true;
  }

  handleAccept() {
    alert(this.state.selected);
  }

  handleDeny() {
    alert(this.state.selected);
  }

  handleRowActive(id: string):boolean {
    if (this.state.selected.indexOf(id) === -1) {
      return false;
    }
    return true;
  }

  render() {

    return (
      <div>
        <Table celled selectable striped>
          <Table.Header>
            <Table.Row>
              <Table.HeaderCell />
              <Table.HeaderCell textAlign={'center'}>No.</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Host IP</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Host Mac</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Host Name</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Created At</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>API Key</Table.HeaderCell>
            </Table.Row>
          </Table.Header>

          <Table.Body>
            {this.data.map((probe: any, index: number) => (
              <Table.Row key={index} onClick={this.handleSelect.bind(this, probe.id)} active={this.handleRowActive(probe.id)}>
                <Table.Cell collapsing>
                  <Checkbox checked={this.checkExist(probe.id)} />
                </Table.Cell>
                <Table.Cell textAlign={'center'}>{index + 1}</Table.Cell>
                <Table.Cell textAlign={'center'}>{probe.ipAddress}</Table.Cell>
                <Table.Cell textAlign={'center'}>{probe.macAddress}</Table.Cell>
                <Table.Cell>{probe.hostName}</Table.Cell>
                <Table.Cell textAlign={'center'}></Table.Cell>
                <Table.Cell textAlign={'center'}>{probe.apiKey}</Table.Cell>
              </Table.Row>
            ))}
          </Table.Body>

          <Table.Footer fullWidth>
            <Table.Row>
              <Table.HeaderCell />
              <Table.HeaderCell colSpan='6'>
                <Button primary floated={'right'} onClick={this.handleAccept.bind(this)}>Accept</Button>
                <Button floated={'right'} onClick={this.handleDeny.bind(this)}>Deny</Button>
              </Table.HeaderCell>
            </Table.Row>
          </Table.Footer>
        </Table>
      </div>
    );
  }
}



