import * as React from 'react';
import { Button, Table, Label, Segment, Header } from 'semantic-ui-react';
import { TargetTable } from './Targets';
import { DetailContainer } from './commons/DetailContainer';

export class ProbeDetails extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  componentWillMount() {

  }

  render() {
    const items = [
      { name: 'Info', child: <ProbeBasicInfo probe={this.props.probe}/> },
      { name: 'Targets', child: <TargetTable /> },
    ];
    return (
      <DetailContainer panes={items}/>
    );
  }
}

export class ProbeBasicInfo extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  handleStartStop(event: any, data: any) {
    console.log(event);
  }
  handleDiscovery(event: any, data: any) {
    alert('Discovery');
  }

  handleBack(event: any, data: any) {
    this.props.onBack();
  }


  showStartStopBtn() {
    if (this.props.probe.metaProbeStatus.name === 'STARTED') {
      return <Button content='Stop' icon='stop' labelPosition='left' color={'blue'} floated={'right'} onClick={this.handleStartStop} />;
    } else {
      return <Button content='Start' icon='play' labelPosition='left' color={'blue'} floated={'right'} onClick={this.handleStartStop} />;
    }
  }

  render() {
    return (
      <Segment.Group>
        <Segment inverted color='grey'>
          <h4>Probe Details</h4>
        </Segment>
        <Segment>
          <Table celled={false} basic='very'>
            <Table.Body>
              <Table.Row>
                <Table.Cell>
                  <Header size='small'>Domain</Header>
                </Table.Cell>
                <Table.Cell>{this.props.probe.domain.name}</Table.Cell>
              </Table.Row>
              <Table.Row>
                <Table.Cell>
                  <Header size='small'>Status</Header>
                </Table.Cell>
                <Table.Cell>{this.props.probe.metaProbeStatus.name}</Table.Cell>
              </Table.Row>
              <Table.Row>
                <Table.Cell>
                  <Header size='small'>Host IP</Header>
                </Table.Cell>
                <Table.Cell>????</Table.Cell>
              </Table.Row>
              <Table.Row>
                <Table.Cell>
                  <Header size='small'>Host Name</Header>
                </Table.Cell>
                <Table.Cell>????</Table.Cell>
              </Table.Row>
              <Table.Row>
                <Table.Cell>
                  <Header size='small'>Authorized at</Header>
                </Table.Cell>
                <Table.Cell>{this.props.probe.createDate}</Table.Cell>
              </Table.Row>
              <Table.Row>
                <Table.Cell>
                  <Header size='small'>Description</Header>
                </Table.Cell>
                <Table.Cell>{this.props.probe.description}</Table.Cell>
              </Table.Row>

              <Table.Row>
                <Table.Cell colSpan='4'>
                  <Button content='Back' icon='left arrow' labelPosition='left' onClick={this.handleBack.bind(this)} />
                  <Button content='Discovery' icon='search' labelPosition='left' floated={'right'} positive onClick={this.handleDiscovery} />
                  {this.showStartStopBtn()}

                </Table.Cell>
              </Table.Row>
            </Table.Body>
          </Table>
        </Segment>
      </Segment.Group>
    );
  }
}