import * as React from 'react';
import { Table, Button } from 'semantic-ui-react';
import { SensorDetails } from './SensorDetails';

export class Sensors extends React.Component<any, any> {

  private data: any;

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
      selected: null,
       isDetail: false, //temp
    };
  }

  componentWillMount() {
    this.data = [
      {
        "id": "111",
        "metaSensorStatus": {
          "name": "NORMAL"
        },
        "target": {
          "id": "1",
        },
        "metaCrawler": {
          "name": "WMI",
          "description": "WMI description",
        },
        "crawlerInputItems": "json value",
        "description": "description1111111111",
      },
      {
        "id": "222",
        "metaSensorStatus": {
          "name": "NORMAL"
        },
        "target": {
          "id": "1",
        },
        "metaCrawler": {
          "name": "SNMP",
          "description": "SNMP description",
        },
        "crawlerInputItems": "json value",
        "description": "description1111111111",
      },
      {
        "id": "333",
        "metaSensorStatus": {
          "name": "NORMAL"
        },
        "target": {
          "id": "1",
        },
        "metaCrawler": {
          "name": "JMX",
          "description": "JMX description",
        },
        "crawlerInputItems": "json value",
        "description": "description1111111111",
      },
    ];
  }

  handleSelect(selectedSensor: object) {
    this.setState({
      selected: selectedSensor,
      isDetail: true,
    });
  }

  checkCellStatus(status: any): boolean {
    if (status.name === 'STOPPED') {
      return true;
    }
    return false;
  }

  showStartStopBtn(status: any) {
    if (status.name === 'STARTED') {
      return <Button content='Stop' icon='stop' labelPosition='left' color={'blue'} floated={'right'} onClick={this.handleStartStop} />;
    } else {
      return <Button content='Start' icon='play' labelPosition='left' color={'blue'} floated={'right'} onClick={this.handleStartStop} />;
    }
  }

  handleStartStop(event: any, data: any) {
    console.log(event);
  }
  handleAddSensor() {
    console.log('adding a sensor');
  }

  render() {
    if (this.state.isDetail) {
      return <SensorDetails sensor={this.state.selected} />;
    } 
    return (
      <div>
        <Table celled selectable striped>
          <Table.Header>
            <Table.Row>
              <Table.HeaderCell textAlign={'center'}>No.</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Status</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Crawler</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Description</Table.HeaderCell>
              <Table.HeaderCell textAlign={'center'}>Item count</Table.HeaderCell>
            </Table.Row>
          </Table.Header>

          <Table.Body>
            {this.data.map((sensor: any, index: number) => (
              <Table.Row key={index} onClick={this.handleSelect.bind(this, sensor)}>
                <Table.Cell textAlign={'center'}>{index + 1}</Table.Cell>
                <Table.Cell negative={this.checkCellStatus(sensor.metaSensorStatus)} textAlign={'center'}>{sensor.metaSensorStatus.name}</Table.Cell>
                <Table.Cell>{sensor.metaCrawler.name}</Table.Cell>
                <Table.Cell>{sensor.description}</Table.Cell>
                <Table.Cell>to do</Table.Cell>
                {/* <Table.Cell collapsing>{this.showStartStopBtn(sensor.metaSensorStatus)}</Table.Cell> */}
              </Table.Row>
            ))}
          </Table.Body>
        </Table>
        <Button content='Add' icon='add' labelPosition='left' floated='right' positive onClick={this.handleAddSensor.bind(this)} />
      </div>
    );
  }
}



